/**
 *
 */
/* Includes *******************************************************************/
#include "main.h"

int main (void)
{
  /* Initialization */

  Init_SysTick();
  Init_GPIO();
  Init_FSMC();
  Init_LCD();

  /* Demo */

  Demo_MMIA();
  Delay_ms(3000);

  while(1)
  {
    Draw_Image(0, 319, 240, 320, mandelbrot1);
    Delay_ms(3000);
    
    Draw_Image(0, 319, 240, 320, mandelbrot2);
    Delay_ms(3000);
    
    Draw_Image(0, 319, 240, 320, mandelbrot3);
    Delay_ms(3000);

    Draw_Image(0, 319, 240, 320, mandelbrot4);
    Delay_ms(3000);
  }

  return 0;
}

/*
 * Demonstration project designed for MMIA.
 */

void Demo_MMIA()
{
  Clear_Screen(0x0000);

  Set_Font(&Font16x24);
  Display_String(14, 295, "MMIA PROJEKT 2012", LCD_WHITE);
  Display_String(72, 287, "DEMONSTRACNY KIT", LCD_WHITE);
  Set_Font(&Font12x12);
  Display_String(97, 285, "pre STM32F4-Discovery", LCD_WHITE);

  Draw_Image(120, 206, 54, 93, logo_urel);

  Set_Font(&Font8x8);
  Display_String(220, 259, "Jakub Lanik, Jakub Nedoma", LCD_WHITE);
  Display_String(230, 259, "Martin Tajc, Martin Serik", LCD_WHITE);

  Delay_ms(7000);

  Clear_Screen(0x0000);
  Set_Font(&Font16x24);
  Display_String(107, 255, "Random Lines", LCD_WHITE);

  Delay_ms(2000);
  Clear_Screen(0x0000);
  Random_Lines();
  Delay_ms(500);

  Clear_Screen(0x0000);
  Set_Font(&Font16x24);
  Display_String(107, 295, "Random Rectangles", LCD_WHITE);

  Delay_ms(2000);
  Clear_Screen(0x0000);
  Random_Rect();
  Delay_ms(500);

  Clear_Screen(0x0000);
  Set_Font(&Font16x24);
  Display_String(107, 271, "Random Circles", LCD_WHITE);

  Delay_ms(2000);
  Clear_Screen(0x0000);
  Random_Circle();
  Delay_ms(500);

  Clear_Screen(0x0000);
  Set_Font(&Font16x24);
  Display_String(107, 199, "Image", LCD_WHITE);

  Delay_ms(2000);
  Draw_Image(0, 319, 240, 320, wave);
}

/*
 * Draw random lines.
 */

void Random_Lines()
{
  uint16_t x1,y1,x2,y2;
  uint32_t i;
  uint16_t cr;

  for(i=0;i<9000;i++)
  {
    x1=rand() % 240;  /*TODO: in Eclipse yields rand() error (no reference to _sbrk) */
    y1=rand() % 320;
    x2=rand() % 240;
    y2=rand() % 320;

    cr=rand();

    Draw_Line(x1, y1 ,x2 ,y2 , cr << 3);
  }
}

/*
 * Draw random rectangles.
 */

void Random_Rect()
{
  uint16_t x1,y1,x2,y2;
  uint32_t i;
  uint16_t cr;

  for(i=0;i<500;i++)
  {
    x1=rand() % 240;  /*TODO: in Eclipse yields rand() error (no reference to _sbrk) */
    y1=rand() % 320;
    x2=rand() % 240;
    y2=rand() % 320;

    cr=rand();

    Draw_Rect(x1, y1 ,x2 ,y2 , cr << 3);
  }
}

/*
 * Draw random circles.
 */

void Random_Circle()
{
  uint16_t x, y, r;
  uint32_t i;
  uint16_t cr;

  for(i=0;i<6000;i++)
  {
    x=rand() % 140;  /*TODO: in Eclipse yields rand() error (no reference to _sbrk) */
    y=rand() % 220;
    r=(rand() % 50) + 1;

    cr=rand() << 3;

    Draw_Circle(x+50, y+50, r, cr);
  }
}

















